Subject: Headers--References, In-Reply-To:

From: Being Riptup <[email-masked]>
Date: Tue, 17 Feb 1998 12:50:53 -0700 (MST)

Hav you guys noticed that the references and In-Reply-To headers duplicate
the same purpose? In fact the USENET references header, which usually
includes all of the references in the message replied to, is more
complete. I'd recommend you discontinue this "In-Reply-To:" header, even
for IMAP or regular e-mail.

I'm using PINE 3.95 on a shared system. This version doesn't let me edit
the references header, even though I explicitly put "References:" in the
"customized-headers" section. The reason I want to edit these is that some
newsreaders display thread nesting, notably DejaNews, and this thread
nesting won't be correct unless you delete every reference but the anchor
and the articles you're quoting.

For getting off the thread's topic, you delete the anchor too. I bet
DejaNews ignores that, and it still makes sense.

Does PINE 3.96 let you edit references if you put "References:" in the
"customized-headers" section?

Pine 3.95 lets you set the Subject as a sorting key. I don't see a
secondary key section. Does PINE 3.96 let you further sort Subject by
thread? Or better yet, does it do basic threading?

---

From: "Adam H. Kerman" <[email-masked]>
Date: Tue, 17 Feb 1998 15:03:24 -0600 (CST)

>From: Being Riptup <[email-masked]>
>Date: Tue, 17 Feb 1998 12:50:53 -0700 (MST)

>for IMAP or regular e-mail.

You are unfamiliar with the history of the headers. The Usenet standard is RFC
1036 and most people agree that it was sloppily written.

The intent was to use the APRA Mail Message standard (RFC 822) for News
articles wherever possible. References in a mail message refers to the Message
ID of another mail message which is referred to in the body of the main
message. In-Reply-To indicates that this message is a reply to a specific
message. There is nothing in the Mail standard (RFC 822) that would have
prevented this header from containing the Message-IDs of earlier messages in
the thread.

Unfortunately, RFC 1036 changed this.

For a good discussion of header issues, see RFC 2076: Common Internet Message
Headers. While RFC 1036 remains the official Internet standard, well-behaved
news readers no longer follow it. They use, instead, another document which
never even made it to the RFC stage called "son-of-RFC1036: News Article Format
and Transmission", which you can ftp from zoo.toronto.edu. The file is called
news.txt.Z in the pub directory.

>"customized-headers" section.

You may not edit this header, nor In-Reply-To. Furthermore, pine refused to
post a follow-up to what you claim was a news article, unless the Path header
is present. Without it, pine only posts to mail.

>The reason I want to edit these is that some newsreaders display thread
>nesting, notably DejaNews, and this thread nesting won't be correct unless you
>delete every reference but the anchor and the articles you're quoting.

The thread nesting is correct as long as no one deliberately edits the
References header and sticks in a Message-ID that doesn't belong. Surely, you
have not found this to be a common problem.

>DejaNews ignores that, and it still makes sense.

If you "get off the thread's topic", then don't post a followup! Begin a new
thread. If, on the other hand, the Subject header is no longer descriptive of
your followup article, change it! There is an informal way of doing that:

Subject: New topic (was: Old topic)

Some people leave the Re: in (was: Re: Old topic), but I think it looks silly.

Even more informally, if you followup to such a message, your subject should
read Subject: Re: New topic, deleting the parenthetical Old topic.

>"customized-headers" section?

No. This behavior is the same.

>Pine 3.95 lets you set the Subject as a sorting key. I don't see a secondary
>key section.

There isn't one. You'd have to select specific messages, save them to another
folder, and perform another primary sort on the second folder.

>Does PINE 3.96 let you further sort Subject by thread? Or better yet, does it
>do basic threading?

No threading yet; the only other option is Ordered Subject sort, which also
performs a "secondary" sort by date.

You want threading? Use trn.

---

From: Being Riptup <[email-masked]>
Date: Sat, 21 Feb 1998 04:22:50 -0700 (MST)

> prevented this header from containing the Message-IDs of earlier messages in

You don't argue against References and In-Reply-To being duplicate though. 
In fact you provide more evidence of the fact, enabling In-Reply-To: to
hav multiple IDs.

> news.txt.Z in the pub directory.

Tkx. Wil view. If that answers not, I'll see RFC1036.

> have not found this to be a common problem.

No. I have wondered if <ftp://zoo.toronto.edu/new.txt.Z> would be an
invalid reference, even if few news-readers would parse and follow it. 
Lynx uses "X-URL: http://..." to comment on HTML, and I see no reason not
to allow including that reference in either In-Reply-To: or References:.

You'd just put them in <> and ignore non-news articles for threading.
You'd assume articles wer news by default.
Examples:
	<[email-masked]>
	<mailto:[email-masked]//subject="help"/send>
	<http://www.freenet.edmonton.ab.ca/>

Generally though, I only want access to References: to delete references
to articles I DON'T refer to. Many newsreaders, PINE included, don't
mention other articles in the reply's body automatically, so I imagine
deleting unintended references or In-Reply-Tos can't be mechanized
accurately.

You could get an incomplete reference-not list by eliminating user IDs and
names not mentioned in the body.

AltaVista lets you view documents referred to. Let me cut the clutter by
deleting references not used.

> your followup article, change it! There is an informal way of doing that:

I don't understand why getting off the thread's topic and having a reason
to change the subject are on different hands. 

> Subject: Re: New topic

Unless this informality becomes standard, these will always be two threads
separated by O,P, and Q. I prefer to go straight to the new topic, even
though following up to something in a different thread.

My reasoning is simple: The reference is there if your reader can follow
it.. Most newsreaders won't attempt to thread articles with different
subjects: that might result some kind of tree.

AltaVista and DejaNews on the other hand let you see how someone could be
following-up to an article and be starting a thread at the same time: the
last reference would be in a different thread, maybe even in a different
group.

> Some people leave the Re: in (was: Re: Old topic), but I think it looks silly.

I think it's silly to mention the old topic in a new thread: Write two
articles unless you're relating two topics.

> You want threading? Use trn.

There's a host of trade-offs between Tin and PINE. Generally I prefer
PINE, kuz if the modems hav been 100% loaded for the last five minutes, I
hav a 1hr session limit and Tin's way of postponing articles is very
messy: you post them, mail them to yourself and cancel them. I'm serious.
I've never bothered to check if it has an automatic save & restart, kuz it
has no save-working-text or postpone.

---

From: "Adam H. Kerman" <[email-masked]>
Date: Sat, 21 Feb 1998 12:42:32 -0600 (CST)

>Date: Sat, 21 Feb 1998 04:22:50 -0700 (MST)

>>articles wherever possible. References in a mail message refers to the
>>Message ID of another mail message which is referred to in the body of the
>>main message. In-Reply-To indicates that this message is a reply to a
>>specific message. There is nothing in the Mail standard (RFC 822) that would
>>have prevented this header from containing the Message-IDs of earlier
>>messages in the thread.

>In fact you provide more evidence of the fact, enabling In-Reply-To: to

But, in mail, it isn't traditional to have more than one Message-ID in
In-Reply-To. It should be assumed that most MUAs would choke, and newsreaders
would ignore it. It's an unfortunate situation that we're stuck with.

>invalid reference, even if few news-readers would parse and follow it.

Heh. That would be, since the file's called news.txt.Z.

>to allow including that reference in either In-Reply-To: or References:.

Don't do it, because comments must be in parethesis, not angle brackets.
Son-of-1036 has a good discussion of this very issue. These lines must only
contain precursor Message-IDs. Web pages can't be precursors. This is a
standard format, therefore it can be used to move along the article tree.

>You'd assume articles wer news by default.

Although, if I had stored both news and mail on my system in mail format, it
would be nice to go back and forth along the thread, if some of it came in
private mail replies. But, you are suggesting using URL format which won't be
recognized by existing News readers for the purpose you suggest. Proper News
readers have no trouble using the Message-IDs to find the articles.

>deleting unintended references or In-Reply-Tos can't be mechanized

You are missing the point. You want articles that you write to be properly
threaded when read by others. You have no control over what articles have and
have not expired on news servers. The more Message-IDs of precursor articles
you leave on the References header, the more likely your article can be
properly threaded when it arrives on another news server.

In Mail, References is used so that the reader can refer to other mail messages
that aren't precursors in the thread to this message. Son-of-1036 suggested a
new header in News for this purpose: See-Also. He also suggested that gateways
convert References between In-Reply-To and See-Also as appropriate, although he
did admit that if a thread-precursor References header were left in a Message
converted from News to Mail that mail readers wouldn't choke on it.

>names not mentioned in the body.

Yes, the person writing the new message should do that anyway.

>deleting references not used.

Again, that's not how References is used in News; don't do it.

>>your followup article, change it!

>to change the subject are on different hands.

Some people read a News article and post a followup that is irrelevant to that
article. That's the first hand. Other people post a valid followup to an
article just read that contains nothing of the Subject of the message that
began the article tree, but fail to change the Subject. That's the second hand.

>>There is an informal way of doing that:

>though following up to something in a different thread.

No; the thread means the precursor articles, not all articles with a specific
Subject. An article tree is a group of articles that are all successors to the
same article. Are all articles with Subject: Help!!!!! in the same thread?

As I said, it's an informality, and it's controversial having an article with a
transition Subject. I do it, but lots of people don't.

>it. Most newsreaders won't attempt to thread articles with different

But, the ability to do it should be left intact. It's sort of a convention that
became established before threading News readers were available. As users
become more advanced and realize what they are missing, they'll start using
News readers that provide additional functionality.

>following-up to an article and be starting a thread at the same time: the last
>reference would be in a different thread, maybe even in a different group.

Again, that's the same thread, but with a new Subject. The interface the 2 are
using recognizes the Message IDs on the References header and converts them
into URLs to help navigate around their own servers. Which is fine.

There is no good reason for News articles to be composed with precursor
Message-IDs in URL format.

>articles unless you're relating two topics.

Nah, what usually happens is that the original Subject should have been changed
3 articles earlier in the thread, and you are getting around to changing it!

>There's a host of trade-offs between Tin and PINE.

Not tin; trn.